/*
    $Id: limage.h,v 1.1.1.1 2001/08/21 10:04:43 samwise97 Exp $

    image.h -- definition of Image class
    Copyright (C) 2001 Iwan Mouwen <iwan@vvier.tudelft.nl>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef LIMAGE_H
#define LIMAGE_H

//class QTimer;


#include <qwidget.h>
#include <qpoint.h>
#include <qpixmap.h>



class LImage : public QWidget
{
    Q_OBJECT
public:
	LImage( bool fixed, QWidget *parent=0, const char *name=0 );
	~LImage();
	void setImage ( QImage *image );
	void setSister ( LImage *sister );
	void gotoXY ( QPoint p, bool tell_sister=true );
	void gotoXY ( int x, int y, bool tell_sister=true );
	void draw( QRect r );
	QPoint getOffset();	

protected:
	void paintEvent( QPaintEvent *e );
	void mousePressEvent( QMouseEvent * );
	void mouseReleaseEvent( QMouseEvent * );
	void resizeEvent ( QResizeEvent * );
private:
	QPoint calculateGlobalXY( QPoint p );
	bool ffixed;
	/*  if LImage is fixed, theimage points to a copy of the map, otherwise
 	 *  it is a pointer to the real map
         */
	QImage *ftheimage;
	QPixmap *pm;		// used to reduce flicker
	LImage *fsister;
	int fx, fy;
	
	int Xscale, Yscale;	// used for fixed LImages
	QPoint *Offset;		// used for scalable LImages
};


#endif // LIMAGE_H
