/*
    $Id: lotrmap.h,v 1.1.1.1 2001/08/21 10:04:43 samwise97 Exp $

    lotrmap.h --
    Copyright (C) 2001 Iwan Mouwen <iwan@vvier.tudelft.nl>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef LOTRMAP_H
#define LOTRMAP_H

#define LOTRMAP_VERSION "0.9"

#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qlist.h>
#include <qstring.h>
#include <qimage.h>
#include <qmsgbox.h>
#include <qcombobox.h>

#include "limage.h"
#include "place.h"


class Lotrmap : public QMainWindow
{
	Q_OBJECT
	
	public:
		Lotrmap();
		~Lotrmap();

		void initActions();
		void initMenuBar();

		void initWidgets();

	public slots:
		void slotFileQuit();
		void slotHelpAbout();
		void slotReadMap();
		void slotReadTranslation();
		void slotCbSelectActivated( int index );

	private:
		void readConfig();
		void readMaps();
		void openImageFile( const QString &filename );
		void openTranslationFile( const QString &language );

		QPopupMenu * fileMenu;
		QPopupMenu * helpMenu;

		QAction * fileQuit;
		QAction * helpAboutApp;
		QAction * viewStatusBar;

		QImage * theimage;
		LImage * bigimage;
		LImage * smallimage;
		QComboBox * cb_select;
		QComboBox * cb_search;

		QList<QAction> maps;
		QList<QAction> translations;
		QPopupMenu * mapsMenu;
		QPopupMenu * translationsMenu;
		Places * places;
		Places * found_places;
		/**
		 * name of the current Region, eg "Middle-Earth"
		 */
		QString currentMap;	
		/** currently selected Language
		 *  the translationfile to read is "currentMap_currentLanguage.dat"
		 */
		QString currentLanguage;
};
#endif 
