/*
    $Id: place.h,v 1.1.1.1 2001/08/21 10:04:43 samwise97 Exp $

    place.h --
    Copyright (C) 2001 Iwan Mouwen <iwan@vvier.tudelft.nl>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef PLACE_H
#define PLACE_H

#include <qsortedlist.h>
#include <qstring.h>
#include <qstringlist.h>
#include <qpoint.h>

class Place;


class Place
{
public:
	Place( const QString &name, const QPoint &point );
	~Place();

	QString getName() { return name; }
	QPoint getPoint() { return point; }
	bool contains( const QString &name ) const;
	bool operator==( const Place & p ) const { return name == p.name; }
	bool operator<( const Place & p ) const { return name < p.name; }
	bool operator>( const Place & p ) const { return name > p.name; }

private:
	QString name;
	QPoint point;
};

class Places
{
public:
	Places( bool AutoDelete = false );
	~Places();
	void add( const QString &name, const QPoint &point );
	void add( const QString &name, const QString &point );
	void add( const Place * place );
	QPoint get( unsigned int index );
	void clear() { placeList.clear(); }
	Places grep( const QString &str );
	QStringList getList();

private:			
	QSortedList<Place> placeList;

protected:

};

#endif //PLACE_H
